ASSEMBLE
    CLRLIST	NOLIST,ALL
RPL

*****************************************************************************
* Modulname:	42
* Modultype:	Header file
* Dest.Comp.:	HP-48
* Language:	System RPL
* Author:	Detlef Mueller,Bellerbek 33,2000 Hamburg 56,Tel.040/8119280
* Interface:	INCLUDE	42.h
* Description:	Usefull RPL tools
* Edition History :
*	1.000	13.08.1991	DM	Alpha version
*	  001	13.02.1992	DM	add debug support
*****************************************************************************

    STITLE	RPL Tools


*** DBGHLT1/DBGHLTN *********************************************************
* Description:
*	Insert DBGHLT at the points, you want to see the stack. 1st call is
*	DBGHLT1, all following calls are DBGHLTN
* Edition History:
*	1.000	13.02.1992	DM	Alpha version
*****************************************************************************

DEFINE	DBGHLT1	NULLNAME DBGHLT :: HARDBUFF TOTEMPOB 1LAMBIND DispStack WaitForKey DROP ZEROZERO 1GETABND XYGROBDISP kcEnter #= ?SEMI AtUserStack ABORT ;
DEFINE	DBGHLTN	DBGHLT



    STITLE	Assembler Tools


ASSEMBLE

*** MKGROB ******************************************************************
* Interface:
*	ASSEMBLE
*	MKGROB	x,y
*	NIBHEX	nnnnnnnnn ...
*	RPL
* Description:
*	The following macro could be used to generate GROB definitions due
*	the lack of the RPLCOMP build in command GROB.
* Edition History:
*	1.000	13.08.1991	DM	Alpha version
*****************************************************************************

MKGROB	MACRO		* x,y
	CON(5)	=DOGROB
	CON(5)	15+(($1+7)/8)*$2*2
	CON(5)	$2
	CON(5)	$1
MKGROB	ENDM

*** MKSGROB *****************************************************************
* Interface:
*	ASSEMBLE
*	MKSGROB	x,y,nnnnnnnn ...
*	RPL
* Descrpition:
*	The following macro could be used to generate small GROB definitions
*	(no more than 80 nibbles in hxs field) due the lack of the RPLCOMP
*	build in command GROB.
* Edition History:
*	1.000	17.08.1991	DM	Alpha version
*****************************************************************************

MKSGROB	MACRO		* x,y,nnnn
	CON(5)	=DOGROB
	CON(5)	15+(($1+7)/8)*$2*2
	CON(5)	$2
	CON(5)	$1
	NIBHEX	$3
MKSGROB	ENDM

*** DOMSG *******************************************************************
* Interface:
*	ASSEMBLE
*	DOMSG	RomId,MsgNr
*	RPL
* Descrpition:
*	The following macro could be used to generate a message number from
*	a given ROMID and message offset.
* Edition History:
*	1.000	25.08.1991	DM	Alpha version
*****************************************************************************

DOMSG	MACRO	* RomId,MsgNr
	CON(5)	=DOBINT
	CON(5)	($1)*256+($2)		* (ROMID << 8) | msgnr *
DOMSG	ENDM


    SETLIST	NOLIST,ALL

RPL
